const mongoose = require('mongoose');
const express = require('express');
const parser = require('body-parser')
const fs = require('fs');

const connection_string = 'mongodb://127.0.0.1/responsibilities';

mongoose.connect(connection_string, { useNewUrlParser: true });
mongoose.connection.on('error', () => {
  console.log('There was a problem connecting to mongoDB');
});

var ItemSchema = new mongoose.Schema( {
    name: String,
    difficulty: Number,
    stat: String,
    category: String
});
var Item = mongoose.model('Item', ItemSchema);

var CategorySchema = new mongoose.Schema( {
  name: String,
  priority: Number,
  color: String
});
var Category = mongoose.model('Category', CategorySchema);

/*
var testItem1 = new Item({
    name: 'go to work',
    difficulty: 5,
    stat: 'inprogress'
});
var testItem2 = new Item({
    name: 'study',
    difficulty: 7,
    stat: 'not started'
});

let p1 = testItem1.save();
p1.catch( (err) => { console.log(err); });
let p2 = testItem2.save();
p2.catch( (err) => { console.log(err); });
*/

const app = express();
app.use(express.static('public_html'))
app.use(express.json())

// WE NEED TO CHANGE THIS ROUTE
app.get('/items/:cat', (req, res) => {
    let cat = req.params.cat;
    let p1 = Item.find({category: cat}).exec();
    p1.then( (results) => { 
      res.end( JSON.stringify(results) );
    });
    p1.catch( (error) => {
      console.log(error);
      res.end('FAIL');
    });
});

app.post('/create/item/', (req, res) => {
  let newItemToSave = req.body;
  console.log(newItemToSave);
  var newItem = new Item(newItemToSave);
  let p1 = newItem.save();
  p1.then( (doc) => { 
    res.end('SAVED SUCCESFULLY');
  });
  p1.catch( (err) => { 
    console.log(err);
    res.end('FAIL');
  });
});

app.post('/create/category/', (req, res) => {
  let CategoryToSave = req.body;
  var newCategory = new Category(CategoryToSave);
  let p1 = newCategory.save();
  p1.then( (doc) => { 
    res.end('SAVED SUCCESFULLY');
  });
  p1.catch( (err) => { 
    console.log(err);
    res.end('FAILED TO CREATE A CATEGORY');
  });
});

app.get('/categories/', (req, res) => {
    let p1 = Category.find({}).exec();
    p1.then( (results) => { 
      res.end( JSON.stringify(results) );
    });
    p1.catch( (error) => {
      console.log(error);
      res.end('FAIL');
    });
});

const port = 80;
app.listen(port, () => {
  console.log('server has started');
});

